module fourDigitSevenSegmentDisplay(clk, in, out);

input clk;
input [15:0] in;
output [27:0] out;

sevenSegDisplay sa(clk, in[15:12], out[27:21]);
sevenSegDisplay sb(clk, in[11:8], out[20:14]);
sevenSegDisplay sc(clk, in[7:4], out[13:7]);
sevenSegDisplay sd(clk, in[3:0], out[6:0]);

endmodule



module sevenSegDisplay(clk, in, out);
input clk;
input [3:0] in;
output [6:0] out;

reg [6:0] out;

always @(posedge clk) begin
  out[0] <= in[3] | (in[2] & in[0]) | in[1] | ((~in[2]) & (~in[0]));
  out[1] <= ((~in[1]) & (~in[0])) | (in[1] & in[0]) | (~in[2]);
  out[2] <= in[2] | (~in[1]) | in[0];
  out[3] <= ((~in[2]) & (~in[0])) | (in[1] & (~in[0])) | (in[2] & (~in[1]) & in[0]) | ((~in[2]) & in[1]);
  out[4] <= ((~in[2]) & (~in[0])) | (in[1] & (~in[0]));
  out[5] <= in[3] | ((~in[1]) & (~in[0])) | (in[2] & (~in[0])) | (in[2] & (~in[1]));
  out[6] <= in[3] | (in[1] & (~in[0])) | (in[2] & (~in[1])) | ((~in[2]) & in[1]);
end

endmodule
