module CONTROLLER (CLK, ENABLE, X_COORD, Y_COORD, SCAN_CODE, RGB_VAL) ;
input CLK;
input ENABLE;
input [9:0] X_COORD, Y_COORD;
input [7:0] SCAN_CODE;
output [2:0] RGB_VAL;
reg [2:0] RGB_VAL;
reg [9:0] X_VAL_LOW, X_VAL_HIGH, Y_VAL_LOW, Y_VAL_HIGH;
reg [15:0] COUNTER;

always @(posedge CLK) begin
	if(SCAN_CODE == 'h76) begin
		X_VAL_LOW = 300;
		X_VAL_HIGH = 350;
		Y_VAL_LOW = 250;
		Y_VAL_HIGH = 300;
		COUNTER <= 0;
	end
	if(ENABLE) begin		// if the logical and of HRGB and VRGB is 1, do something
		COUNTER <= COUNTER + 1;
		if(COUNTER == 0)begin
			case (SCAN_CODE)
			'h75: begin		// up arrow
				if(Y_VAL_LOW == 0) begin
					Y_VAL_LOW = 0;
				end
				else begin
					Y_VAL_LOW = Y_VAL_LOW - 1;
				end
				if(Y_VAL_HIGH == 50) begin
					Y_VAL_HIGH = 50;
				end
				else begin
					Y_VAL_HIGH = Y_VAL_HIGH - 1;
				end 
			end
			'h72: begin		// down arrow
				if(Y_VAL_LOW == 430) begin
					Y_VAL_LOW = 430;
				end
				else begin
					Y_VAL_LOW = Y_VAL_LOW + 1;
				end
				if(Y_VAL_HIGH == 480) begin
					Y_VAL_HIGH = 480;
				end
				else begin
					Y_VAL_HIGH = Y_VAL_HIGH + 1;
				end 
			end
			'h6b: begin		// left arrow
				if(X_VAL_LOW == 0) begin
					X_VAL_LOW = 0;
				end
				else begin
					X_VAL_LOW = X_VAL_LOW - 1;
				end
				if(X_VAL_HIGH == 50) begin
					X_VAL_HIGH = 50;
				end
				else begin
					X_VAL_HIGH = X_VAL_HIGH - 1;
				end 
			end
			'h74: begin		// right arrow
				if(X_VAL_LOW == 590) begin
					X_VAL_LOW = 590;
				end
				else begin
					X_VAL_LOW = X_VAL_LOW + 1;
				end
				if(X_VAL_HIGH == 640) begin
					X_VAL_HIGH = 640;
				end
				else begin
					X_VAL_HIGH = X_VAL_HIGH + 1;
				end 
			end
			'h76: begin		// escape key - return to default settings
				X_VAL_LOW = 300;
				X_VAL_HIGH = 350;
				Y_VAL_LOW = 250;
				Y_VAL_HIGH = 300;
			end
			'h29: begin		// space bar
			end
			default: begin		// any other key
			end
			endcase
		end
		if(X_COORD < X_VAL_HIGH && X_COORD > X_VAL_LOW && Y_COORD > Y_VAL_LOW && Y_COORD < Y_VAL_HIGH) begin
			RGB_VAL <= 'b100;
		end
		else begin
			RGB_VAL <= 'b0;
		end
	end
	else begin			// otherwise, do nothing
		RGB_VAL <= 0;
	end	
end

// add your declarations here

// add your code here

endmodule 
