module enbl(clk, one, two, three, x, y, en, enBall);

input clk;
input one, two, three;
input [9:0] x, y;
output en, enBall;

reg [1:0] speed; // 0, 1, 2 (see always block)

// en is the signal used to move the paddle
// enBall is the signal used to move the ball
assign en = ((x == 0 || x == 8 || x == 16) && y == 0) ? 1 : 0;
assign enBall = (((x == 0) || (x == 8 && speed != 0) || (x == 16 && speed == 2)) && (y == 0)) ? 1 : 0;

always @(posedge clk) begin
  if (one)
    speed <= 0;
  else if (two)
    speed <= 1;
  else if (three)
    speed <= 2;
end

endmodule
