module IMGCTL (KEYBOARD, X, Y, CLK, ADDR, WE, BG) ;

input [7:0] KEYBOARD ;
input [9:0] X ;
input [9:0] Y ;
input CLK ;
output [7:0] ADDR ;
output WE ;
output BG ;

reg [7:0] ADDR, tempKey;
reg WE, BG, didKeyAlready;

// add your declarations here

reg [9:0] X1, Y1, newX1, newY1;
reg [4:0] Xcnt, Ycnt;
reg [4:0] scale, newScale;
reg [8:0] scale16;

always @(posedge CLK) begin
  WE <= 0;
  scale16 = scale << 4;
  
  if(X==0 & Y==0) begin
    ADDR <= 0;
    scale = newScale;
    X1 = newX1;
    Y1 = newY1;
    Xcnt = newScale;
    Ycnt = newScale;
    BG <= 1;
  end
  
  if(X>=0 & Y>=0 & X<640 & Y<480) begin
  
    if((X >= X1 & X < (X1+scale16)) & (Y >= Y1 & Y < (Y1+scale16))) begin
      if(X==X1) begin
        BG <= 0;
      end
      if(Xcnt == 0) begin
        Xcnt = scale;
        ADDR <= ADDR + 1;
      end
      else
        Xcnt = Xcnt - 1;
      // Decrement the address when we return to the beginning of the line
      if(X == X1 & Ycnt != 0 & Y != Y1) begin
        Ycnt = Ycnt - 1;
        ADDR <= ADDR - 15;
      end
      if(Ycnt == 0)
        Ycnt = scale;
    end
    else begin
      BG <= 1;
    end
  
  end
  else
    ADDR <= 0;

  if(!didKeyAlready) begin
    case(KEYBOARD)
      8'h2d: begin
             newScale <= 16;
             scale = 16;
             newX1 <= 0;
             newY1 <= 0;
             X1 = 0;
             Y1 = 0;
      end
      8'h79: begin
             newScale <= newScale + 1;
      end
      8'h7b: begin
             newScale <= newScale - 1;
      end
      8'h75: begin
             if(newY1 > 0)
               newY1 <= newY1 - 1;
      end
      8'h72: begin
             if((newY1+scale16) < 479)
               newY1 <= newY1 + 1;
      end
//      8'h6b: begin
//             if(newX1 > 0)
//               newX1 <= newX1 - 1;
//      end
//      8'h74: begin
//             if((newX1+scale16) < 639)
//               newX1 <= newX1 + 1;
//      end
    endcase
    didKeyAlready <= 1;
    tempKey <= KEYBOARD;
  end
  if(tempKey != KEYBOARD)
    didKeyAlready <= 0;
end

// add your code here

endmodule 
