module LFSR (CLK, SCAN_CODE, X_COORD, RAND_NUM) ;
input CLK ;
input [7:0] SCAN_CODE;
input [9:0] X_COORD;
output [9:0] RAND_NUM;
reg [9:0] RAND_NUM;
reg STEP0, STEP1, STEP2, STEP3, STEP4, STEP5, STEP6, STEP7, STEP8, STEP9;
reg FIRST_TIME;

always @(posedge CLK) begin
	if(SCAN_CODE == 'h76) begin	// initialize
		STEP0 <= 0;
		STEP1 <= 0;
		STEP2 <= 0;
		STEP3 <= 0;
		STEP4 <= 0;
		STEP5 <= 0;
		STEP6 <= 0;
		STEP7 <= 0;
		STEP8 <= 0;
		STEP9 <= 0;
		FIRST_TIME <= 1;
	end
	else begin
		if(FIRST_TIME == 1) begin
			FIRST_TIME <= 0;
			STEP9 <= X_COORD[9];
			STEP8 <= X_COORD[8];
			STEP7 <= X_COORD[7];
			STEP7 <= X_COORD[6];	
			STEP5 <= X_COORD[5];
			STEP4 <= X_COORD[4];	
			STEP3 <= X_COORD[3];
			STEP2 <= X_COORD[2];	
			STEP1 <= X_COORD[1];
			if(X_COORD == 0) begin	// make sure LFSR can not be seeded with 0
				STEP0 <= 1;
			end
			else begin
				STEP0 <= X_COORD[0];	
			end
		end
		else begin
			STEP1 <= STEP0;
			STEP2 <= STEP1;
			STEP3 <= (STEP2 & ~STEP9) | (STEP9 & ~STEP2);
			STEP4 <= STEP3;
			STEP5 <= STEP4;
			STEP6 <= STEP5;
			STEP7 <= STEP6;
			STEP8 <= STEP7;
			STEP9 <= STEP8;
			STEP0 <= STEP9;
		end
	end
	RAND_NUM = {STEP9, STEP8, STEP7, STEP6, STEP5, STEP4, STEP3, STEP2, STEP1, STEP0};
end

endmodule 
