module P_TO_S (CLK, INSTR, NI, DRAW, CHAR, COL, ROW) ;

input CLK ;
input [15:0] INSTR ;
input NI ;
output DRAW ;
output [4:0] CHAR ;
output [6:0] COL ;
output [4:0] ROW ;

// add your declarations here

reg DRAW;
reg [4:0] CHAR;
reg [6:0] COL;
reg [4:0] ROW;
reg [2:0] state;
reg init;

// add your code here

always @ (posedge CLK) begin
  if (~init) begin
    COL <= 45;
    ROW <= 5;
    CHAR[4] <= 0;
    init <= 1;
    state <= 0;
  end

  if (NI | (state > 0)) begin
    case (state)
      0 : begin 
        DRAW <= 1;
        CHAR[3:0] <= INSTR[15:12];
        state <= 1;
      end
      1 : begin
        COL <= COL + 1;
        CHAR[3:0] <= INSTR[11:8];
        state <= 2;
      end
      2 : begin
        COL <= COL + 1;
        CHAR[3:0] <= INSTR[7:4];
        state <= 3;
      end
      3 : begin
        COL <= COL + 1;
        CHAR[3:0] <= INSTR[3:0];
        state <= 4;
      end
      4 : begin
        COL <= 45;
        ROW <= ROW + 1;
        DRAW <= 0;
        state <= 0;
      end
    endcase
  end
end

endmodule 
