module shiftreg (clk, enable, serialin, data) ;

output [19:0] data;
input clk ;
input enable ;
input serialin ;
reg [10:0] mantissa;
reg [7:0] exponent;
reg [5:0] serix;
reg [5:0] manix;
reg sign;
reg v;
reg start;

// will be valid on falling edge of LRCK
assign data = {sign, mantissa, exponent};

always @(posedge clk) begin
	if (enable) begin	
		if (start) sign = serialin;
		else begin
		   if (!v) begin mantissa[manix] = serialin;
		   	if (mantissa) {v,manix} = manix - 1;
		   	else exponent = exponent - 1;
		   end
		end
		start = 0;
	end else begin
		exponent = 8;
		mantissa = 0;
		manix = 10;		
		start = 1;
		v = 0;
	end
end

endmodule 
